using Serilog;
using Elastic.CommonSchema.Serilog;
using PARR.TemplateActivatorWorker;
using PARR.TemplateActivator;

var builder = Host.CreateApplicationBuilder();

builder.Services.AddLogging(config =>
{
    config.ClearProviders();

    var logger = new LoggerConfiguration();

    if (builder.Environment.IsProduction())
        logger.WriteTo.Console(new EcsTextFormatter());
    else
        logger.WriteTo.Console();

    logger.ReadFrom.Configuration(builder.Configuration);

    config.AddSerilog(logger.CreateLogger());
});

builder.Services.InstallTemplateActivatorSerivces(builder.Configuration);
builder.Configuration.AddTemplateActivatorConfigurations(builder.Services);
builder.Services.AddTemplateActivatorSettings(builder.Configuration);

builder.Services.AddHostedService<Worker>();

var host = builder.Build();
host.Run();